/*
This is an Ozeki 433Mhz RF Module example code.

This module has a transmitter and receiver.

You can transmit any integer value (-32,768 to 32,767).
Simply write the number and press Enter to send.

It can also show received signals through the serial port.
*/

#include <RCSwitch.h>
 
RCSwitch myTransmitterSwitch = RCSwitch(); //repeats transmission 10 times
                                           //uses protocol 1
  
RCSwitch myReceiverSwitch = RCSwitch(); //repeats transmission 10 times
                                        //uses protocol 1                               
char inputString[256];
 
void setup() {
  Serial.begin(115200);
  myTransmitterSwitch.enableTransmit(2); // Transmitter is connected to Arduino Pin D2
  myReceiverSwitch.enableReceive(1);  // Receiver on interrupt 1 => that is pin D3
 Serial.println("Please type any int (-32,768 to 32,767) and press Enter.");
 Serial.println("If data is received the program automatically writes it out.");
}
 
void loop() {
  if(Serial.available()){
    delay(1);
    ReadLine();
    myTransmitterSwitch.send(atoi(inputString), 24); //Transmit signal
    Serial.println("");
    Serial.print(atoi(inputString));
    Serial.println(" has been sent.");
    if (myReceiverSwitch.available() &&
          (myReceiverSwitch.getReceivedValue() == atoi(inputString)) )
      myReceiverSwitch.resetAvailable(); //removes transmitted_value from received  
    for(int i=0; i<256; i++)
      inputString[i] = NULL;  
  }
   
   if (myReceiverSwitch.available()) { //Signal received
    int value = myReceiverSwitch.getReceivedValue();
    if (value == 0) {
      Serial.println("Unknown encoding");
    } else {
            Serial.print("Received number: ");
            Serial.println( value );
          }
    myReceiverSwitch.resetAvailable();
  }
   
}
 
void ReadLine() {
  for(int i=0; i<256; i++)
    inputString[i] = NULL;
  int i=0;
  while (Serial.available()) {
    inputString[i] = (char)Serial.read();
    if (inputString[i] == '\n') {
      break;
    }
    i++;
  }
}
